package kr.co.vividnext.sodalive.admin.content.curation

import kr.co.vividnext.sodalive.common.ApiResponse
import org.springframework.security.access.prepost.PreAuthorize
import org.springframework.web.bind.annotation.GetMapping
import org.springframework.web.bind.annotation.PostMapping
import org.springframework.web.bind.annotation.PutMapping
import org.springframework.web.bind.annotation.RequestBody
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.bind.annotation.RestController

@RestController
@RequestMapping("/admin/audio-content/curation")
@PreAuthorize("hasRole('ADMIN')")
class AdminContentCurationController(private val service: AdminContentCurationService) {
    @PostMapping
    fun createContentCuration(
        @RequestBody request: CreateContentCurationRequest
    ) = ApiResponse.ok(service.createContentCuration(request))

    @PutMapping
    fun updateContentCuration(
        @RequestBody request: UpdateContentCurationRequest
    ) = ApiResponse.ok(service.updateContentCuration(request))

    @PutMapping("/orders")
    fun updateContentCurationOrders(
        @RequestBody request: UpdateContentCurationOrdersRequest
    ) = ApiResponse.ok(service.updateContentCurationOrders(request.ids), "수정되었습니다.")

    @GetMapping
    fun getContentCurationList() = ApiResponse.ok(service.getContentCurationList())
}
