package kr.co.vividnext.sodalive.admin.event

import kr.co.vividnext.sodalive.common.ApiResponse
import org.springframework.security.access.prepost.PreAuthorize
import org.springframework.web.bind.annotation.GetMapping
import org.springframework.web.bind.annotation.PostMapping
import org.springframework.web.bind.annotation.PutMapping
import org.springframework.web.bind.annotation.RequestBody
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.bind.annotation.RestController

@RestController
@RequestMapping("/event/charge")
class AdminChargeEventController(private val service: AdminChargeEventService) {
    @PostMapping
    @PreAuthorize("hasRole('ADMIN')")
    fun createChargeEvent(@RequestBody request: CreateChargeEventRequest): ApiResponse<Any> {
        service.createChargeEvent(request)
        return ApiResponse.ok(null, "등록되었습니다.")
    }

    @PutMapping
    @PreAuthorize("hasRole('ADMIN')")
    fun modifyChargeEvent(@RequestBody request: ModifyChargeEventRequest) = ApiResponse.ok(
        service.modifyChargeEvent(request),
        "수정되었습니다."
    )

    @GetMapping("/list")
    @PreAuthorize("hasRole('ADMIN')")
    fun getChargeEventList() = ApiResponse.ok(service.getChargeEventList())
}
