package kr.co.vividnext.sodalive.admin.member.tag

import com.querydsl.jpa.impl.JPAQueryFactory
import kr.co.vividnext.sodalive.member.tag.CreatorTag
import kr.co.vividnext.sodalive.member.tag.QCreatorTag.creatorTag
import org.springframework.data.jpa.repository.JpaRepository

interface AdminMemberTagRepository : JpaRepository<CreatorTag, Long>, AdminMemberTagQueryRepository

interface AdminMemberTagQueryRepository {
    fun findByTag(tag: String): Long?
}

class AdminMemberTagQueryRepositoryImpl(private val queryFactory: JPAQueryFactory) : AdminMemberTagQueryRepository {
    override fun findByTag(tag: String): Long? {
        return queryFactory
            .select(creatorTag.id)
            .from(creatorTag)
            .where(creatorTag.tag.eq(tag))
            .fetchFirst()
    }
}
