package kr.co.vividnext.sodalive.content.main.curation

import kr.co.vividnext.sodalive.common.BaseEntity
import kr.co.vividnext.sodalive.content.AudioContent
import javax.persistence.Column
import javax.persistence.Entity
import javax.persistence.OneToMany
import javax.persistence.Table

@Entity
@Table(name = "content_curation")
data class AudioContentCuration(
    @Column(nullable = false)
    var title: String,
    @Column(nullable = false)
    var description: String,
    @Column(nullable = false)
    var isAdult: Boolean = false,
    @Column(nullable = false)
    var isActive: Boolean = true,
    @Column(nullable = false)
    var orders: Int = 1
) : BaseEntity() {
    @OneToMany(mappedBy = "curation")
    val audioContents: MutableList<AudioContent> = mutableListOf()
}
