package kr.co.vividnext.sodalive.explorer.profile

import kr.co.vividnext.sodalive.common.BaseEntity
import kr.co.vividnext.sodalive.member.Member
import javax.persistence.Column
import javax.persistence.Entity
import javax.persistence.FetchType
import javax.persistence.JoinColumn
import javax.persistence.ManyToOne
import javax.persistence.OneToMany

@Entity
data class CreatorCheers(
    @Column(columnDefinition = "TEXT", nullable = false)
    var cheers: String,
    val isActive: Boolean = true
) : BaseEntity() {
    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "parent_id", nullable = true)
    var parent: CreatorCheers? = null
        set(value) {
            value?.children?.add(this)
            field = value
        }

    @OneToMany(mappedBy = "parent")
    var children: MutableList<CreatorCheers> = mutableListOf()

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "member_id", nullable = false)
    var member: Member? = null

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "creator_id", nullable = false)
    var creator: Member? = null
}
