package kr.co.vividnext.sodalive.live.room.kickout

import org.springframework.data.annotation.Id
import org.springframework.data.redis.core.RedisHash

@RedisHash("live_room_kick_out")
data class LiveRoomKickOut(
    @Id
    val roomId: Long,
    var userList: MutableList<LiveRoomKickOutUser> = mutableListOf()
) {
    fun kickOut(userId: Long) {
        var liveRoomKickOutUser = userList.find { it.userId == userId }
        if (liveRoomKickOutUser == null) {
            liveRoomKickOutUser = LiveRoomKickOutUser(userId)
        } else {
            liveRoomKickOutUser.plusCount()
        }

        userList.removeIf { it.userId == userId }
        userList.add(liveRoomKickOutUser)
    }
}

data class LiveRoomKickOutUser(
    val userId: Long,
    var count: Int = 1
) {
    fun plusCount() {
        count += 1
    }
}
